Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.beans
Class Family

    java.lang.Object

      |

      +--oracle.ifs.beans.LibraryObject

            |

            +--oracle.ifs.beans.TieLibraryObject

                  |

                  +--oracle.ifs.beans.PublicObject

                        |

                        +--oracle.ifs.beans.TiePublicObject

                              |

                              +--oracle.ifs.beans.Family

All Implemented Interfaces:
  IfsEventHandler, LibraryObjectInterface, PublicObjectInterface, Traceable

Direct Known Subclasses:
  TieFamily

public class Family
extends TiePublicObject

The Family class is one of the classes that allow PublicObjects to be versioned. Any Object that is versioned will belong to one and only one Family, which represents all the versions as a PublicObject entity.

The Family class allows you to navigate to all instances of a PublicObject that comprise that entity.

The Family class has two special attributes. DefaultVersionDescription and PrimaryVersionSeries. The DefaultVersionDescription is fully updatable and can be used to designate a Published version in which people not actively working on a versioned object might be interested. The PrimaryVersionSeries is used to designate the most active or desirable version series to be used as a default series in a number of versioning operations. For example, PublicObject has a number of versioning convenience methods that operate only on the primary version series.

If a DefaultVersionDescription is not set (is null) then a request for a resolved public object will be deferred to the PrimaryVersionSeries.

See Also:
  `PublicObject`

Field Summary
`static java.lang.String` | `CLASS_NAME` This class name for this class.
`static java.lang.String` | `DEFAULTVERSIONDESCRIPTION_ATTRIBUTE` The VersionDescription which will be used as the ResolvedPublicObject for this Family.
`static java.lang.String` | `PRIMARYVERSIONSERIES_ATTRIBUTE` If the DefaultVersionDescription is null, the VersionSeries which will be used as the ResolvedPublicObject for this Family.

Fields inherited from class oracle.ifs.beans.PublicObject
`ACL_ATTRIBUTE, ADMINISTRATIONGROUP_ATTRIBUTE, CREATEDATE_ATTRIBUTE, CREATOR_ATTRIBUTE, DELETOR_ATTRIBUTE, DESCRIPTION_ATTRIBUTE, EXPIRATIONDATE_ATTRIBUTE, FAMILY_ATTRIBUTE, FLAGS_ATTRIBUTE, LASTMODIFIER_ATTRIBUTE, LASTMODIFYDATE_ATTRIBUTE, LOCKEDFORSESSION_ATTRIBUTE, LOCKSTATE_ATTRIBUTE, LOCKSTATE_HARDLOCK, LOCKSTATE_SESSIONLOCK, LOCKSTATE_SOFTLOCK, LOCKSTATE_UNLOCK, LOCKSTATE_USERLOCK, NAME_ATTRIBUTE, OWNER_ATTRIBUTE, POLICYBUNDLE_ATTRIBUTE, PROPERTYBUNDLE_ATTRIBUTE, RESOLVEDPUBLICOBJECT_ATTRIBUTE, SECURINGPUBLICOBJECT_ATTRIBUTE`

Method Summary
`VersionDescription` | `getDefaultVersionDescription()` Gets the default VersionDescription of this family.
`VersionSeries` | `getPrimaryVersionSeries()` Gets the PrimaryVersionSeries in this Family.
`PublicObject` | `getResolvedPublicObject()` Returns the PublicObject to which this object resolves.
`void` | `setDefaultVersionDescription(VersionDescription version)` Sets the default VersionDescription of this Family.
`void` | `setPrimaryVersionSeries(VersionSeries series)` Sets the PrimaryVersionSeries of this Family.

Methods inherited from class oracle.ifs.beans.PublicObject
`addCategory, addRelationship, checkEffectiveAccess, checkEffectiveAccess, copy, getAcl, getAllFolderPaths, getAllFolderPaths, getAnyFolderPath, getAnyFolderPath, getCategories, getCategories, getCreateDate, getCreator, getDefaultAccessLevel, getDescription, getEffectiveAccessLevel, getEffectiveAccessLevel, getExpirationDate, getFamily, getFlags, getFolderReferencesSortSpecification, getLastModifier, getLastModifyDate, getLeftwardRelationshipObjects, getLeftwardRelationshipObjects, getLeftwardRelationships, getLeftwardRelationships, getLockedState, getLockState, getLockStateLabel, getOwner, getPolicyBundle, getPropertyBundle, getRightwardRelationshipObjects, getRightwardRelationshipObjects, getRightwardRelationships, getRightwardRelationships, getSecuringPublicObject, grantAccess, handleEvent, hasNameAttribute, isLocked, isLockedForSession, isLockedForSessionByCurrentSession, isVersionable, isVersioned, lock, putPolicy, putProperty, putProperty, removeAllPolicies, removeAllProperties, removePolicy, removePolicy, removeProperty, removeRelationship, revokeAccess, revokeAllAccess, setAcl, setDescription, setExpirationDate, setFlags, setFolderReferencesSortSpecification, setOwner, setPolicyBundle, setPropertyBundle, setSecuringPublicObject, toLockStateLabel, toLockStateLabel, toLockStateLabel, unlock`

Methods inherited from class oracle.ifs.beans.LibraryObject
`equals, free, free, getAttribute, getAttributeByUpperCaseName, getAttributes, getAttributesByUpperCaseNames, getClassId, getClassObject, getDefinition, getId, getLabel, getName, getSession, invokeServerMethod, isInstanceOf, isTraced, lookupInstanceLabel, postEvent, postEvent, renderAsReader, renderAsStream, setAttribute, setAttribute, setAttributes, setAttributes, setName, toString, trace, update`

Methods inherited from interface oracle.ifs.common.LibraryObjectInterface
`getId`

Methods inherited from interface oracle.ifs.common.Traceable
`getTraceLogger, isTraced, trace`

Field Detail

### CLASS_NAME

    public static final java.lang.String CLASS_NAME

  This class name for this class. Useful for methods that take a class name argument.

### PRIMARYVERSIONSERIES_ATTRIBUTE

    public static final java.lang.String PRIMARYVERSIONSERIES_ATTRIBUTE

  If the DefaultVersionDescription is null, the VersionSeries which will be used as the ResolvedPublicObject for this Family.

### DEFAULTVERSIONDESCRIPTION_ATTRIBUTE

    public static final java.lang.String DEFAULTVERSIONDESCRIPTION_ATTRIBUTE

  The VersionDescription which will be used as the ResolvedPublicObject for this Family. If null, the ResolvedPublicObject for this Family will be the PrimaryVersionSeries.

Method Detail

### getDefaultVersionDescription

    public VersionDescription getDefaultVersionDescription()
                                                    throws IfsException

  Gets the default VersionDescription of this family. This may be null if no default VersionDescription is set.
  Returns:
    the default object, or null.
  Throws:
    `IfsException` - if operation fails.

### setDefaultVersionDescription

    public void setDefaultVersionDescription(VersionDescription version)
                                      throws IfsException

  Sets the default VersionDescription of this Family. The default VersionDescription need not reside in the PrimaryVersionSeries (but it does need to be in this family).
  Parameters:
    `version` - the desired default VersionDescription.
  Throws:
    `IfsException` - if operation fails.

### getPrimaryVersionSeries

    public VersionSeries getPrimaryVersionSeries()
                                          throws IfsException

  Gets the PrimaryVersionSeries in this Family.
  Returns:
    the PrimaryVersionSeries.
  Throws:
    `IfsException` - if operation fails.

### setPrimaryVersionSeries

    public void setPrimaryVersionSeries(VersionSeries series)
                                 throws IfsException

  Sets the PrimaryVersionSeries of this Family.
  Parameters:
    `series` - VersionSeries to be set as primary.
  Throws:
    `IfsException` - if operation fails.

### getResolvedPublicObject

    public PublicObject getResolvedPublicObject()
                                         throws IfsException

  Returns the PublicObject to which this object resolves. For the non version classes (for example, Document and Folder) this simply returns itself (`this`). For the version classes, (Family, VersionSeries, and VersionDescription), this will return a non version-class object as determined by the configuration of the instance of the version class.

  This override exists to return the Pending PublicObject value of the primary VersionSeries if the caller is the Reservor of that VersionSeries; in all other cases, it defers to the implementation in the superclass (PublicObject).

  Overrides:
    `getResolvedPublicObject` in class `PublicObject`
  Returns:
    PublicObject to which this object resolves
  Throws:
    `IfsException` - if operation fails.
  See Also:
    `PublicObject.getResolvedPublicObject()`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD